## krazy2 0~git20101204

=== cppchecks/CMakeLists.txt ===
project(cppchecks)
cmake_minimum_required(VERSION 2.6)

include(CheckCXXCompilerFlag)

set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)

check_cxx_compiler_flag(-fvisibility=hidden __KRAZY_HAVE_GCC_VISIBILITY)
set( __KRAZY_HAVE_GCC_VISIBILITY ${__KDE_HAVE_GCC_VISIBILITY} CACHE BOOL "GCC support for hidden visibility")

set(CPP_SOURCE_DIR ${CMAKE_SOURCE_DIR}/cplusplus/)

set(CPP_PREPROCESSOR_SOURCE_DIR ${CMAKE_SOURCE_DIR}/cplusplus/preprocessor)
set(CPP_PARSER_SOURCE_DIR ${CMAKE_SOURCE_DIR}/cplusplus/parser)
set(CPP_TOOLS_SOURCE_DIR ${CMAKE_SOURCE_DIR}/cplusplus/tools)

configure_file(krazymacros.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/krazymacros.h)

add_definitions(-DCPLUSPLUS_WITH_NAMESPACE=1 -DHAVE_QT)

set(INSTALL_TARGETS_DEFAULT_ARGS RUNTIME DESTINATION bin
                                 LIBRARY DESTINATION lib${LIB_SUFFIX}
                                 ARCHIVE DESTINATION lib${LIB_SUFFIX})

# This is the cplusplus parser from QtCreator which can be found at
add_subdirectory(cplusplus)
add_subdirectory(checkutil)
add_subdirectory(checks)
add_subdirectory(gui)

=== doc/Makefile ===
# krazy docs Makefile
#
# Copyright 2007 by Allen Winter <winter@kde.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See th
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

PERLDOC=perldoc

#default installation location
PREFIX=/usr/local

krazyrc.5 : krazyrc.pod
	$(PERLDOC) $? > $@

all: krazyrc.5

install:: all
	@if test ! -d $(DESTDIR); then \
		mkdir -p $(DESTDIR) || exit 1; \
	fi

	@if test ! -d $(DESTDIR)/man5; then \
		mkdir -p $(DESTDIR)/$(PREFIX)/man/man5 || exit 1; \
	fi

	list=krazyrc.5; for man in $$list; do \
		echo "Installing man page $$man"; \
		mv -f $$man $(DESTDIR)/$(PREFIX)/man/man5/$$man; \
	done

clean:
	@echo "Nothing to clean"

realclean: clean

=== extras/Makefile ===
# krazy extras Makefile
#
# Copyright 2007-2008 by Allen Winter <winter@kde.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See th
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# list of all extra subdirs to install
SUBDIRS = \
c++ \
designer \
desktop \
general \
kconfigxt \
kpartgui \
tips \

#default installation location
PREFIX=/usr/local
INSTDIR=$(PREFIX)/lib$(LIBSUFFIX)/krazy2/krazy-extras

all:

install::
	@if test ! -d $(DESTDIR)$(INSTDIR); then \
		mkdir -p $(DESTDIR)$(INSTDIR) || exit 1; \
	fi
	list="$(SUBDIRS)"; for dir in $$list; do \
		echo "Installing extras subdir $$dir"; \
		( cd $$dir && make install ); \
	done

clean:
	list="$(SUBDIRS)"; for dir in $$list; do \
		echo "Cleaning extras subdir $$dir"; \
		( cd $$dir && make clean ); \
	done

realclean: clean

=== helpers/Makefile ===
# krazy helpers Makefile
#
# Copyright 2007 by Allen Winter <winter@kde.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See th
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# list of all helpers to install
HELPERS = \
getInstalledHeaders.pl

#default installation location
PREFIX=/usr/local
INSTDIR=$(PREFIX)/lib$(LIBSUFFIX)/krazy2/krazy-helpers

all:

install::
	@if test ! -d $(DESTDIR)$(INSTDIR); then \
		mkdir -p $(DESTDIR)$(INSTDIR) || exit 1; \
	fi
	list="$(HELPERS)"; for helper in $$list; do \
		echo "Installing helper $$helper"; \
		cp -f $$helper $(DESTDIR)$(INSTDIR)/$$helper; \
	done

clean:
	@echo "Nothing to clean"

realclean: clean

=== plugins/Makefile ===
# krazy plugins Makefile
#
# Copyright 2007-2008,2010 by Allen Winter <winter@kde.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See th
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# list of all plugin subdirs to install
SUBDIRS = \
general \
c++ \
designer \
desktop \
kconfigxt \
messages \
kpartgui \
tips \
qml \
qdoc

#default installation location
PREFIX=/usr/local
INSTDIR=$(PREFIX)/lib$(LIBSUFFIX)/krazy/krazy-plugins

all:

install::
	list="$(SUBDIRS)"; for dir in $$list; do \
		echo "Installing plugin subdir $$dir"; \
		( cd $$dir && make install ); \
	done

clean:
	list="$(SUBDIRS)"; for dir in $$list; do \
		echo "Cleaning plugin subdir $$dir"; \
		( cd $$dir && make clean ); \
	done

realclean: clean

=== sets/Makefile ===
# krazy sets Makefile
#
# Copyright 2010 by Allen Winter <winter@kde.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See th
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# list of all set subdirs to install
SUBDIRS = \
c++ \
qt4 \
kde4 \
foss \

#default installation location
PREFIX=/usr/local
INSTDIR=$(PREFIX)/lib$(LIBSUFFIX)/krazy/krazy-sets

all:

install::
	list="$(SUBDIRS)"; for dir in $$list; do \
		echo "Installing set subdir $$dir"; \
		( cd $$dir && make install ); \
	done

clean:
	list="$(SUBDIRS)"; for dir in $$list; do \
		echo "Cleaning set subdir $$dir"; \
		( cd $$dir && make clean ); \
	done

realclean: clean

=== cppchecks/checks/CMakeLists.txt ===
set(CHECKUTIL_SOURCE_DIR ${CMAKE_SOURCE_DIR}/checkutil)

include_directories(
  ${QT_INCLUDE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_BINARY_DIR}
  ${CPP_SOURCE_DIR}
  ${CHECKUTIL_SOURCE_DIR}
)

add_subdirectory(dpointercheck)

=== cppchecks/checkutil/CMakeLists.txt ===
include_directories(
  ${QT_INCLUDE_DIR}
  ${CPP_PREPROCESSOR_SOURCE_DIR}
  ${CPP_PARSER_SOURCE_DIR}
  ${CMAKE_BINARY_DIR}
)

set(checkutil_SRCS
  checkengine.cpp
  check.cpp
)
add_library(checkutil SHARED ${checkutil_SRCS})

target_link_libraries(checkutil
    preprocessor
    cpp_parser
)
set_target_properties(checkutil PROPERTIES VERSION 1 SOVERSION 1.0)
install(TARGETS checkutil ${INSTALL_TARGETS_DEFAULT_ARGS})

=== cppchecks/cplusplus/CMakeLists.txt ===
add_definitions(${QT_DEFINITIONS})

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(cppmodel)
add_subdirectory(parser)
add_subdirectory(preprocessor)

=== cppchecks/gui/CMakeLists.txt ===
include_directories(
  ${QT_INCLUDE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CPP_SOURCE_DIR}
)

set(APP_SRCS
  asttreemodel.cc
  symboltreemodel.cc
  includestreemodel.cc
  messagetablemodel.cc
  parseresultwidget.cc
  main.cc
)

set(APP_MOC_HDRS
  parseresultwidget.h
)

qt4_wrap_ui(APP_UI_HDRS parseresultwidget.ui)
qt4_wrap_cpp(APP_MOC_SRCS ${APP_MOC_HDRS})

add_executable(parse_result_analyzer ${APP_SRCS} ${APP_MOC_SRCS} ${APP_UI_HDRS})
target_link_libraries(parse_result_analyzer
  ${QT_QTCORE_LIBRARY}
  ${QT_QTGUI_LIBRARY}
  cpp_parser
  preprocessor
  cppmodel
)

if(WIN32)
install(TARGETS parse_result_analyzer ${INSTALL_TARGETS_DEFAULT_ARGS})
endif(WIN32)

=== extras/c++/Makefile ===
# krazy extras/c++ Makefile
#
# Copyright 2007-2009 by Allen Winter <winter@kde.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See th
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# list of all extras to install
EXTRAS = \
camelcase \
defines \
kdebug \
multiclasses \
null \
qenums \
style \
tipsandthis \

# links to general purpose extras
EXTRALNS = \
contractions \

#default installation location
PREFIX=/usr/local
INSTDIR=$(PREFIX)/lib$(LIBSUFFIX)/krazy2/krazy-extras/c++

all:

install::
	@if test ! -d $(DESTDIR)$(INSTDIR); then \
		mkdir -p $(DESTDIR)$(INSTDIR) || exit 1; \
	fi

	cp -f description.txt $(DESTDIR)$(INSTDIR)

	list="$(EXTRAS)"; for extra in $$list; do \
		echo "Installing extra $$extra"; \
		cp -f $$extra $(DESTDIR)$(INSTDIR)/$$extra; \
	done
	list="$(EXTRALNS)"; for extra in $$list; do \
		echo "Installing extra link $$extra"; \
		ln -sf ../general/$$extra $(DESTDIR)$(INSTDIR)/$$extra; \
	done

clean:
	@echo "Nothing to clean"

realclean: clean

=== extras/designer/Makefile ===
# krazy extras/designer Makefile
#
# Copyright 2008 by Allen Winter <winter@kde.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See th
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# list of all extras to install
EXTRAS = \
tipsandthis \

# links to general purpose extras
EXTRALNS = \
contractions \

#default installation location
PREFIX=/usr/local
INSTDIR=$(PREFIX)/lib$(LIBSUFFIX)/krazy2/krazy-extras/designer

all:

install::
	@if test ! -d $(DESTDIR)$(INSTDIR); then \
		mkdir -p $(DESTDIR)$(INSTDIR) || exit 1; \
	fi

	cp -f description.txt $(DESTDIR)$(INSTDIR)

	list="$(EXTRAS)"; for extra in $$list; do \
		echo "Installing extra $$extra"; \
		cp -f $$extra $(DESTDIR)$(INSTDIR)/$$extra; \
	done
	list="$(EXTRALNS)"; for extra in $$list; do \
		echo "Installing extra link $$extra"; \
		ln -sf ../general/$$extra $(DESTDIR)$(INSTDIR)/$$extra; \
	done

clean:
	@echo "Nothing to clean"

realclean: clean

=== debian/changelog ===
krazy2 (0~git20101204-1) experimental; urgency=low

  * Initial release (Closes: #594366)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Tue, 14 Dec 2010 23:10:44 +0100

=== debian/control ===
Source: krazy2
Section: devel
Priority: extra
Maintainer: José Manuel Santamaría Lema <panfaust@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), libqt4-dev
Standards-Version: 3.9.1
Homepage: http://www.englishbreakfastnetwork.org/
#Vcs-Git: git://git.debian.org/collab-maint/krazy.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/krazy.git;a=summary

Package: krazy2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends},
 libxml-libxml-perl, libhtml-parser-perl, libtie-ixhash-perl, 
 desktop-file-utils, libxml2-utils
Description: KDE/Qt code source checker
 Krazy scans KDE or Qt source code looking for issues that should be fixed for
 reasons of policy, good coding practice, optimization, or any other good
 reason. In typical use, Krazy simply counts up the issues and provides the line
 numbers where those issues occurred in each file processed.
 .
 This package provides the following programs:
  - krazy2 - checks one or various files given in command line
  - krazy2all - checks all supported files under the current directory
 .
 These programs are being used by official KDE developers to find issues in
 their software, in fact they have a web page (English Breakfast Network a.k.a.
 EBN) which displays the daily results of running these programs against their
 code, see:
 http://www.englishbreakfastnetwork.org/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

TEMPDIR := $(shell mktemp -u)

# Copied from /usr/share/cdbs/1/rules/buildvars.mk
VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
NOEPOCH_VERSION := $(shell echo $(VERSION) | cut -d: -f2-)
UPSTREAM_VERSION := $(shell echo $(NOEPOCH_VERSION) | sed 's/-[^-]*$$//')

PROJECTNAME := "Krazy source code checker"
PROJSHORTNAME := "Krazy"

get-orig-source:
	mkdir -p $(TEMPDIR)
	git clone git://gitorious.org/krazy/krazy.git $(TEMPDIR)/krazy2
	rm -rf $(TEMPDIR)/krazy2/src/desktop-file-utils-*
	rm -rf $(TEMPDIR)/krazy2/src/cppchecks
	cd $(TEMPDIR)/krazy2 && git log > ChangeLog
	rm -rf $(TEMPDIR)/krazy2/.git
	cd $(TEMPDIR) && tar -cf krazy2-$(UPSTREAM_VERSION).tar krazy2 &&\
		gzip -9 krazy2-$(UPSTREAM_VERSION).tar
	mv $(TEMPDIR)/krazy2-$(UPSTREAM_VERSION).tar.gz ..
	rm -rf $(TEMPDIR)

override_dh_auto_configure:
	dh_testdir
	dh_auto_configure
	cd src && qmake-qt4

override_dh_auto_build:
	dh_testdir
	dh_auto_build
	pod2man -c $(PROJECTNAME) -r $(PROJSHORTNAME) krazy2 > debian/krazy2.1
	pod2man -c $(PROJECTNAME) -r $(PROJSHORTNAME) krazy2all > debian/krazy2all.1
	#pod2man -c $(PROJECTNAME) -r $(PROJSHORTNAME) krazy2xml > debian/krazy2xml.1
	pod2man -c $(PROJECTNAME) -r $(PROJSHORTNAME) \
		--section=5 doc/krazyrc.pod > debian/krazyrc.5
	cd src && $(MAKE)

override_dh_auto_install:
	dh_testdir
	dh_auto_install
	cd helpers && $(MAKE) install PREFIX=$(CURDIR)/debian/krazy2/usr
	cd plugins && $(MAKE) install PREFIX=$(CURDIR)/debian/krazy2/usr
	cd extras && $(MAKE) install PREFIX=$(CURDIR)/debian/krazy2/usr
	cd src && $(MAKE) install INSTALL_ROOT=$(CURDIR)/debian/krazy2/usr
	cd sets && $(MAKE) install PREFIX=$(CURDIR)/debian/krazy2/usr
	dh_install share/* usr/share/dtd
	dh_installman debian/krazy2.1 debian/krazy2all.1 debian/krazyrc.5 #\
		#debian/krazy2xml.1

override_dh_auto_clean:
	dh_testdir
	[ ! -f Makefile ] || touch Makefile
	dh_auto_clean
	cd debian && rm -rf krazy2.1 krazy2all.1 krazyrc.5 #krazy2xml.1
	-cd src && $(MAKE) distclean
